/*
 * File:   vs.c
 * Mp3_03c
 *
 * Created on 2015/05/02, 8:10
 */


void	VS1033RESET(void){
    VS1033COMM(0,0x0004);			//
    delay_cycles(256);                          //
    //_delay(256);              // XC8
    VS1033COMM(0,0x0000);			//
    while(!input(MP3_DREQ));			//
    VS1033COMM(3,0x9000);			//
    delay_cycles(256);
    //_delay(256);              // XC8
    VS1033COMM(11,((uint16_t)VOLUME<<8)|((uint16_t)VOLUME));
    delay_cycles(256);
    //_delay(256);              // XC8
}

void	VS1033COMM(uint8_t addr, uint16_t arg){
    output_low(MP3_CS);
    VS1033WRITE(2);
    VS1033WRITE(addr);
    VS1033WRITE(arg>>8);
    VS1033WRITE(arg);
    output_high(MP3_CS);
}

void	VS1033WRITE(uint8_t data){
    int16 i;

    for(i=0;i<8;i++)
    {
        if(data & 0x80)
        {
            output_high(MP3_SI);
        }
        else
        {
            output_low(MP3_SI);
        }
        delay_cycles(4);
        //_delay(4);              // XC8
        output_high(MP3_SCLK);
        delay_cycles(4);
        //_delay(4);              // XC8
        data<<=1;
        output_low(MP3_SCLK);
        delay_cycles(4);
        //_delay(4);              // XC8
    }
    output_high(MP3_SI);
    delay_cycles(4);
    //_delay(4);              // XC8
}

void
VS1033SENDBYTE(uint8_t data){
    int     c;

    output_high(MP3_BSYNC);
    for(c=0; c<8; c++){
        if(data & 0x80){
            output_high(MP3_SI);
        } else {
            output_low(MP3_SI);
        }
        output_high(MP3_DCLK);
        data <<= 1;
        output_low(MP3_DCLK);
        output_low(MP3_BSYNC);
    }
}

uint8_t
VS1033SENDDATA(uint8_t DATA[], uint16_t br){
    int16     i, j, sendbyte;
    uint8_t	data;
    int16     idxPlay;

    idxPlay = 0;

    for (j=0; j<16; j++){
        while(!(input(MP3_DREQ)));

        if (br >= SEND_SIZE) sendbyte = SEND_SIZE;
        else sendbyte = br;
        for (i=0; i<sendbyte; i++){
            data = *(DATA + idxPlay + i);
            VS1033SENDBYTE(data);
        }

        if (sendbyte < SEND_SIZE){
            break;
        }
        idxPlay += sendbyte;
        br -= sendbyte;
    }

    return (0);
}

